diff --git a/bin/varnishd/common/common_vsm.c b/bin/varnishd/common/common_vsm.c
index cb440c9121..f24841c65e 100644
--- a/bin/varnishd/common/common_vsm.c
+++ b/bin/varnishd/common/common_vsm.c
@@ -179,6 +179,7 @@ VSM_common_cleaner(struct vsm_sc *sc, struct VSC_C_main *stats)
 		if (vr->cool > now)
 			break;
 		VTAILQ_REMOVE(&sc->r_cooling, vr, list);
+		sc->g_cooling -= vr->len;
 		vsm_common_insert_free(sc, vr);
 	}
 	stats->vsm_free = sc->g_free;
diff --git a/bin/varnishtest/tests/r01984.vtc b/bin/varnishtest/tests/r01984.vtc
new file mode 100644
index 0000000000..b8b4a12928
--- /dev/null
+++ b/bin/varnishtest/tests/r01984.vtc
@@ -0,0 +1,18 @@
+varnishtest "g_cooldown counter test"
+
+server s1 {} -start
+varnish v1 -vcl+backend {} -start
+varnish v1 -cliok "param.set vsm_free_cooldown 10.0"
+
+# Load and use a new VCL, freeze the first
+varnish v1 -vcl+backend {}
+varnish v1 -cliok "vcl.state vcl1 cold"
+
+# the VSM_common_cleaner runs every 1.1 seconds.
+# Wait for it to update vsm_cooling
+delay 2
+varnish v1 -expect vsm_cooling > 0
+
+# Wait long enough for all the cooling vsm memory to be transfered to the free list:
+delay 12
+varnish v1 -expect vsm_cooling == 0
